/*-
 * Copyright (c) 2008 Vincenzo Iozzo <snagg@sikurezza.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/mman.h>
#include <errno.h>

/* Change it if there is not enough size or similar */
#define	MAX_OBJECT_SIZE		5000000

int main(int argc, char **argv) 
{
	int sfd, nsfd;
	unsigned long *ldr_ptr;
	struct sockaddr_in addr;
	unsigned char *buf;
	
	if (argc < 2) {
		printf("Usage:\n");
		printf("\t%s <port>\n", argv[0]);
		exit(0);
	}
	
	//change the address if the binary is too big
	buf = (unsigned char*)mmap(0x10000000, MAX_OBJECT_SIZE, PROT_READ|PROT_WRITE|PROT_EXEC, MAP_PRIVATE|MAP_ANON, -1, 0);
	
	addr.sin_family = AF_INET;
	addr.sin_port = htons(atoi(argv[1]));
	addr.sin_addr.s_addr = 0;
	
	if ((sfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
		perror("socket()");
		exit(errno);
	}
	
	if (bind(sfd, (struct sockaddr *)&addr, sizeof(struct sockaddr_in)) == -1) {
		perror("bind()");
		exit(errno);
	}
	
	if (listen(sfd, 10) == -1) {
		perror("listen()");
		exit(errno);
	}
	
	if ((nsfd = accept(sfd, NULL, NULL)) == -1) {
		perror("accept()");
		exit(errno);
	}
		
	recv(nsfd, buf, MAX_OBJECT_SIZE, MSG_WAITALL);
	
	ldr_ptr = (unsigned long *)&buf[0];
	*ldr_ptr += (unsigned long)buf;
	
	__asm__(
			"push %0\n"
			"jmp *%1"
			:
			: "c"(buf),"d"(*ldr_ptr)
			);
	
	return (0);
}

